module Network.Pushbullet.Types
( -- * Pagination
  Paginated(..)
, Cursor
  -- * Pushes
, Push(..)
, PushData(..)
, PushTarget(..)
, simpleNewPush
, ExistingPushes(..)
  -- * Ephemerals
, Ephemeral(..)
, PushEphemeral(..)
, EphemeralTarget
, TickleType(..)
, Notification(..)
  -- ** Ephemeral targets
, allEphemeralTargets
, ephemeralTargetIOS
, ephemeralTargetAndroid
, ephemeralTargetStream
  -- * Devices
, Device(..)
, DeviceId(..)
, Nickname(..)
, Manufacturer(..)
, Model(..)
, DeviceIcon(..)
, AppVersion(..)
, KeyFingerprint(..)
, PushToken(..)
, HasSms(..)
, ExistingDevices(..)
, newDevice
  -- ** Device icons
, deviceIconDesktop
, deviceIconBrowser
, deviceIconWebsite
, deviceIconLaptop
, deviceIconTablet
, deviceIconPhone
, deviceIconWatch
, deviceIconSystem
  -- * Users
, User(..)
, UserId(..)
  -- * Permanents
, Permanent(..)
, PermanentK(..)
  -- ** SMS
, SmsThreads(..)
, SmsThread(..)
, SmsThreadId(..)
, SmsThreadRecipient(..)
, SmsMessages(..)
, SmsMessage(..)
, SmsId(..)
, SmsDirection(..)
, SmsMessageType(..)
  -- * Misc
  --
  -- ** Data
, ChannelTag(..)
, ClientId(..)
, EmailAddress(..)
, Guid(..)
, MimeType(..)
, Name(..)
, PhoneNumber(..)
, PushId(..)
, PushbulletTime(..)
, Status(..)
, TrivialObject(..)
, Url(..)
, minPushbulletTime

  -- ** Type-level stuff
, EqT

  -- * Lenses
  -- ** Device
, deviceId
, deviceActive
, deviceCreated
, deviceModified
, deviceIcon
, deviceNickname
, deviceGeneratedNickname
, deviceManufacturer
, deviceModel
, deviceAppVersion
, deviceFingerprint
, deviceKeyFingerprint
, deviceHasSms
, devicePushToken
  -- ** User
, userCreated
, userEmail
, userEmailNormalized
, userId
, userImageUrl
, userMaxUploadSize
, userModified
, userName
  -- ** SMS
, smsDirection
, smsTime
, smsBody
, smsId
, smsSent
, smsType
, recipientName
, recipientAddress
, recipientNumber
, threadId
, threadRecipients
, threadLatest
  -- ** Ephemerals
, ephSmsSourceUser
, ephSmsTargetDevice
, ephSmsConversation
, ephSmsMessage
  -- ** Clipboard
, ephClipBody
, ephClipSourceUser
, ephClipSourceDevice
  -- ** Pagination
, pageData
, pageCursor
) where

import Network.Pushbullet.Types.Device
import Network.Pushbullet.Types.Ephemeral
import Network.Pushbullet.Types.Misc
import Network.Pushbullet.Types.Pagination
import Network.Pushbullet.Types.Permanent
import Network.Pushbullet.Types.Push
import Network.Pushbullet.Types.SMS
import Network.Pushbullet.Types.Status
import Network.Pushbullet.Types.Time
import Network.Pushbullet.Types.User
